<template>
  <div class="q-mt-xl q-ml-md q-mr-md">
    <q-table :rows="rows" :columns="columns" row-key="id" color="amber">
      <template v-slot:body-cell-action="props">
        <q-td :props="props">
          <q-btn
            dense
            round
            flat
            label="edit"
            color="blue"
            @click="(evt) => getRow(evt, props.row)"
          />
          <q-btn
            dense
            round
            flat
            label="delete"
            color="red"
            @click="(evt) => toggleRow(evt, props.row)"
          />
        </q-td> </template
    ></q-table>
    <q-dialog v-model="showDialog" persistent>
      <q-card>
        <q-card-section
          style="
            width: 300px;
            height: 150px;
            display: flex;
            justify-content: center;
            align-items: center;
          "
        >
          <div
            style="display: flex; justify-content: center; align-items: center"
          >
            <h5 class="text-weight-bold text-grey-10">
              Do you want to delete this data?
            </h5>
          </div>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn class="bg-negative" label="delete" @click.stop="deleteNow()" />
          <q-btn flat label="Cancel" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { defineComponent, ref } from "vue";
import { rows, columns, selectedRow, form } from "../composables/users";
import { useRouter } from "vue-router";
import axios from "axios";

export default defineComponent({
  name: "list-user",
  setup() {
    let showDialog = ref(null);
    const router = useRouter();
    const getRow = (evt, row) => {
      const { name, nickname, email, contact, quote } = row;
      selectedRow.value = row;
      Object.assign(form.value, { name, nickname, email, contact, quote });
      router.push({ name: "add-user" });
    };

    const deleteNow = () => {
      axios
        .delete(`http://localhost:3000/users/${toDelete.value.id}`)
        .then((response) => {
          if (response.status === 200) {
            rows.value = rows.value.filter(
              (index) => index.id !== toDelete.value.id
            );
            showDialog.value = false;
          }
        });
    };

    let toDelete = ref(null);
    const toggleRow = (evt, row) => {
      showDialog.value = true;
      toDelete.value = row;
    };

    return {
      rows,
      columns,
      showDialog,
      toggleRow,
      toDelete,
      deleteNow,
      getRow,
    };
  },
});
</script>
